diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index 3086c9d15..c2b1306ca 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -365,18 +365,18 @@ public class Item
     public static Item foodCookie = (new ItemFood("food.cookie", 16485, 1, 0, false, 16));
     public static ItemMap map = new ItemMap("map", 16486);
     public static ItemToolShears toolShears = new ItemToolShears("tool.shears", 16487, ToolMaterial.iron);
-    public static Item record13 = (new ItemRecord("record.13", 18384, "13"));
-    public static Item recordCat = (new ItemRecord("record.cat", 18385, "cat"));
-    public static Item recordBlocks = (new ItemRecord("record.blocks", 18386, "blocks"));
-    public static Item recordChirp = (new ItemRecord("record.chirp", 18387, "chirp"));
-    public static Item recordFar = (new ItemRecord("record.far", 18388, "far"));
-    public static Item recordMall = (new ItemRecord("record.mall", 18389, "mall"));
-    public static Item recordMellohi = (new ItemRecord("record.mellohi", 18390, "mellohi"));
-    public static Item recordStal = (new ItemRecord("record.stal", 18391, "stal"));
-    public static Item recordStrad = (new ItemRecord("record.strad", 18392, "strad"));
-    public static Item recordWard = (new ItemRecord("record.ward", 18393, "ward"));
-    public static Item recordWait = (new ItemRecord("record.wait", 18394, "wait"));
-    public static Item recordDog = (new ItemRecord("record.dog", 18395, "dog"));
+    public static Item record13 = (new ItemRecord("record.13", 18384, "13", "C418"));
+    public static Item recordCat = (new ItemRecord("record.cat", 18385, "cat", "C418"));
+    public static Item recordBlocks = (new ItemRecord("record.blocks", 18386, "blocks", "C418"));
+    public static Item recordChirp = (new ItemRecord("record.chirp", 18387, "chirp", "C418"));
+    public static Item recordFar = (new ItemRecord("record.far", 18388, "far", "C418"));
+    public static Item recordMall = (new ItemRecord("record.mall", 18389, "mall", "C418"));
+    public static Item recordMellohi = (new ItemRecord("record.mellohi", 18390, "mellohi", "C418"));
+    public static Item recordStal = (new ItemRecord("record.stal", 18391, "stal", "C418"));
+    public static Item recordStrad = (new ItemRecord("record.strad", 18392, "strad", "C418"));
+    public static Item recordWard = (new ItemRecord("record.ward", 18393, "ward", "C418"));
+    public static Item recordWait = (new ItemRecord("record.wait", 18394, "wait", "C418"));
+    public static Item recordDog = (new ItemRecord("record.dog", 18395, "dog", "C418"));
     public static Item nethercoal = (new Item("nethercoal", 16488));
     public static Item armorHelmetSteel = (new ItemArmor("armor.helmet.steel", 16489, ArmorMaterial.STEEL, 0));
     public static Item armorChestplateSteel = (new ItemArmor("armor.chestplate.steel", 16490, ArmorMaterial.STEEL, 1));
@@ -428,7 +428,7 @@ public class Item
     public static Item rope = new ItemRope("rope", 16534, Block.rope);
     public static Item foodPumpkinPie = (new ItemPlaceable("food.pumpkin_pie", 16535, Block.pumpkinPie)).setMaxStackSize(1);
     public static Item wandMonsterSpawner = (new ItemWandSpawner("wand.monster", 16536)).setMaxStackSize(1);
-
+    public static Item doorGlassTinted = (new ItemDoor("door.glass.tinted", 16537, Block.doorGlassTintedBottom, Block.doorGlassTintedTop));
 
     public static int highestItemId = 0;
     public int id;
diff --git a/src/main/java/net/minecraft/core/item/ItemRecord.java b/src/main/java/net/minecraft/core/item/ItemRecord.java
index 70e859f16..92f661a18 100644
--- a/src/main/java/net/minecraft/core/item/ItemRecord.java
+++ b/src/main/java/net/minecraft/core/item/ItemRecord.java
@@ -13,12 +13,15 @@ import net.minecraft.core.world.World;
 
 public class ItemRecord extends Item
 {
+    public final String recordName;
+    public final String recordAuthor;
 
 
-    protected ItemRecord(String name, int id, String s)
+    public ItemRecord(String name, int id, String recordName, String recordAuthor)
     {
         super(name, id);
-        recordName = s;
+        this.recordName = recordName;
+        this.recordAuthor = recordAuthor;
         maxStackSize = 1;
     }
 
@@ -38,6 +41,4 @@ public class ItemRecord extends Item
             return false;
         }
     }
-
-    public final String recordName;
 }
diff --git a/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java b/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
index fa214125f..36e513964 100644
--- a/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
+++ b/src/main/java/net/minecraft/core/item/material/ArmorMaterial.java
@@ -1,10 +1,18 @@
 package net.minecraft.core.item.material;
 
-import static net.minecraft.core.util.helper.DamageType.*;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DamageType;
 
-import java.util.*;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
 
-import net.minecraft.core.util.helper.DamageType;
+import static net.minecraft.core.util.helper.DamageType.BLAST;
+import static net.minecraft.core.util.helper.DamageType.COMBAT;
+import static net.minecraft.core.util.helper.DamageType.FALL;
+import static net.minecraft.core.util.helper.DamageType.FIRE;
 
 public class ArmorMaterial {
 	private static final List<ArmorMaterial> ARMOR_MATERIALS = new ArrayList<>();
@@ -17,14 +25,14 @@ public class ArmorMaterial {
 	}
 
 
-	public final String name;
+	public final NamespaceID identifier;
 	public final int durability;
 	public final int renderIndex;
 	
 	private final Map<DamageType, Float> protection = new HashMap<>();
 	
-	public ArmorMaterial(String name, int renderIndex, int durability) {
-		this.name = name;
+	public ArmorMaterial(NamespaceID identifier, int renderIndex, int durability) {
+		this.identifier = identifier;
 		this.renderIndex = renderIndex;
 		this.durability = durability;
 
@@ -44,37 +52,37 @@ public class ArmorMaterial {
 		return this;
 	}
 	
-	public static final ArmorMaterial LEATHER = register(new ArmorMaterial("cloth", 0, 180)
+	public static final ArmorMaterial LEATHER = register(new ArmorMaterial(new NamespaceID("minecraft", "cloth"), 0, 180)
 		.withProtectionPercentage(COMBAT, 20.0f)
 		.withProtectionPercentage(BLAST, 20.0f)
 		.withProtectionPercentage(FIRE, 20.0f)
 		.withProtectionPercentage(FALL, 120.0f)
 	);
-	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial("chain", 1, 240)
+	public static final ArmorMaterial CHAINMAIL = register(new ArmorMaterial(new NamespaceID("minecraft", "chain"), 1, 240)
 		.withProtectionPercentage(COMBAT, 120.0f)
 		.withProtectionPercentage(BLAST, 35.0f)
 		.withProtectionPercentage(FIRE, 35.0f)
 		.withProtectionPercentage(FALL, 35.0f)
 	);
-	public static final ArmorMaterial IRON = register(new ArmorMaterial("iron", 2, 200)
+	public static final ArmorMaterial IRON = register(new ArmorMaterial(new NamespaceID("minecraft", "iron"), 2, 200)
 		.withProtectionPercentage(COMBAT, 45.0f)
 		.withProtectionPercentage(BLAST, 45.0f)
 		.withProtectionPercentage(FIRE, 45.0f)
 		.withProtectionPercentage(FALL, 45.0f)
 	);
-	public static final ArmorMaterial GOLD = register(new ArmorMaterial("gold", 4, 120)
+	public static final ArmorMaterial GOLD = register(new ArmorMaterial(new NamespaceID("minecraft", "gold"), 4, 120)
 		.withProtectionPercentage(COMBAT, 70.0f)
 		.withProtectionPercentage(BLAST, 70.0f)
 		.withProtectionPercentage(FIRE, 70.0f)
 		.withProtectionPercentage(FALL, 70.0f)
 	);
-	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial("diamond", 3, 800)
+	public static final ArmorMaterial DIAMOND = register(new ArmorMaterial(new NamespaceID("minecraft", "diamond"), 3, 800)
 		.withProtectionPercentage(COMBAT, 66.0f)
 		.withProtectionPercentage(BLAST, 66.0f)
 		.withProtectionPercentage(FIRE, 124.0f)
 		.withProtectionPercentage(FALL, 66.0f)
 	);
-	public static final ArmorMaterial STEEL = register(new ArmorMaterial("steel", 5, 1200)
+	public static final ArmorMaterial STEEL = register(new ArmorMaterial(new NamespaceID("minecraft", "steel"), 5, 1200)
 		.withProtectionPercentage(COMBAT, 55.0f)
 		.withProtectionPercentage(BLAST, 150.0f)
 		.withProtectionPercentage(FIRE, 55.0f)
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java
index 285bf53ff..38cc02556 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GameruleCommand.java
@@ -20,10 +20,10 @@ public class GameruleCommand
 
         if (args[0].equalsIgnoreCase("list"))
         {
-            handler.sendCommandFeedback(sender, "List of game rules:");
+            sender.sendMessage("List of game rules:");
             for (GameRule<?> gameRule : Registries.GAME_RULES)
             {
-                handler.sendCommandFeedback(sender, " - " + gameRule.getKey());
+                sender.sendMessage(" - " + gameRule.getKey());
             }
             return true;
         }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
index d41706a07..a66e60b15 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/SpawnParticleCommand.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.command.commands;
 
+import net.minecraft.client.entity.fx.ParticleDispatcher;
 import net.minecraft.core.net.command.ClientCommandHandler;
 import net.minecraft.core.net.command.Command;
 import net.minecraft.core.net.command.CommandHandler;
@@ -31,6 +32,16 @@ public class SpawnParticleCommand extends Command {
         Double maxDistance = null;
         if (args.length >= 1){
             particleKey = args[0];
+
+            if (particleKey.equalsIgnoreCase("list")){
+                sender.sendMessage("List of particles:");
+                for (String s: ParticleDispatcher.getInstance().getParticleIds())
+                {
+                    sender.sendMessage(" - " + s);
+                }
+                return true;
+            }
+
             if (args.length >= 4){
                 x = Double.parseDouble(args[1]);
                 y = Double.parseDouble(args[2]);
@@ -67,6 +78,7 @@ public class SpawnParticleCommand extends Command {
 
     @Override
     public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/spawnparticle list");
         if (sender.getPlayer() != null){
             sender.sendMessage("/spawnparticle <ParticleKey>");
         }
diff --git a/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
new file mode 100644
index 000000000..95aae1e59
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -0,0 +1,38 @@
+package net.minecraft.core.util.collection;
+
+import java.util.Comparator;
+
+public final class NamespaceID implements Comparator<NamespaceID> {
+    public final String namespace;
+    public final String value;
+    public NamespaceID(String namespace, String value){
+        if (namespace.contains(":")) throw new IllegalArgumentException(namespace + " cannot contain the ':' character!");
+        if (value.contains(":")) throw new IllegalArgumentException(value + " cannot contain the ':' character!");
+        this.namespace = namespace;
+        this.value = value;
+    }
+    public NamespaceID(String formattedString){
+        if (!formattedString.contains(":")) throw new IllegalArgumentException("Formatted String '" + formattedString + "' missing ':' character all namespace ids must follow the format <namespace>:<value>!");
+        String[] split = formattedString.split(":");
+        if (split.length != 2) throw new IllegalArgumentException("Formatted String '" + formattedString + "' has more then 1 ':' character! all namespace ids must follow the format <namespace>:<value>!");
+        namespace = split[0];
+        value = split[1];
+    }
+    @Override
+    public int hashCode(){
+        return toString().hashCode();
+    }
+    @Override
+    public boolean equals(Object other){
+        if (other == null) return false;
+        return super.equals(other) | (other.toString().equals(this.toString()));
+    }
+    @Override
+    public String toString(){
+        return namespace + ":" + value;
+    }
+    @Override
+    public int compare(NamespaceID o1, NamespaceID o2) {
+        return o1.toString().compareTo(o2.toString());
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 77f2a3dde..0787f49d3 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -3,11 +3,9 @@ package net.minecraft.core.world;
 // Referenced classes of package net.minecraft.src:
 //            Entity, TileEntity, EntityPlayer
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.sound.SoundCategory;
 
 public interface LevelListener
@@ -40,7 +38,7 @@ public interface LevelListener
 
     void allChanged();
 
-    void playStreamingMusic(String soundPath, int x, int y, int z);
+    void playStreamingMusic(String soundPath, String Author, int x, int y, int z);
 
     void tileEntityChanged(int x, int y, int z, TileEntity tileEntity);
 
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 7df0318d5..e6727abc0 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -63,7 +63,6 @@ import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
-import net.minecraft.core.world.type.WorldTypeDebug;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
@@ -1341,11 +1340,11 @@ public class World implements WorldSource {
         playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x, y, z, name, soundType.modifyVolume(sound.getVolume()), soundType.modifyPitch(sound.getPitch()));
     }
 
-    public void playRecord(String s, int i, int j, int k)
+    public void playRecord(String soundPath, String author, int x, int y, int z)
     {
         for(int l = 0; l < listeners.size(); l++)
         {
-            listeners.get(l).playStreamingMusic(s, i, j, k);
+            listeners.get(l).playStreamingMusic(soundPath, author, x, y, z);
         }
 
     }
diff --git a/src/main/java/net/minecraft/server/world/WorldManager.java b/src/main/java/net/minecraft/server/world/WorldManager.java
index 6730b4ac3..049791685 100644
--- a/src/main/java/net/minecraft/server/world/WorldManager.java
+++ b/src/main/java/net/minecraft/server/world/WorldManager.java
@@ -3,16 +3,12 @@ package net.minecraft.server.world;
 import java.util.HashSet;
 import java.util.Set;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.net.packet.Packet61PlaySoundEffect;
 import net.minecraft.core.net.packet.Packet62PlaySoundDirect;
-import net.minecraft.core.sound.BlockSound;
-import net.minecraft.core.sound.BlockSoundDispatcher;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.LevelListener;
@@ -113,7 +109,7 @@ public class WorldManager
     }
 
     @Override
-	public void playStreamingMusic(String soundPath, int x, int y, int z)
+	public void playStreamingMusic(String soundPath, String Author, int x, int y, int z)
     {
     }
 
